﻿import bMachine.playback.BubbleSound;
import bMachine.button.sdlButton;
/* 
	Playback control: this provides user interaction to navigate & play sound file
		subcomponent buttons:
			toBeginning, butPlay, butPause, & butStop
		methods:
			attachSound, toBeginning, start, pause, stopSound, & update
*/
class bMachine.playback.PlaybackControl extends MovieClip {
	var btnToBeginning:sdlButton;
	var btnPlay:sdlButton;
	var btnStop:sdlButton;
	var btnPause:sdlButton;
	// variable to hold attached BubbleSound object
	var __bubbleSnd:BubbleSound;
	// maintains state of playback
	var __isPlaying:Boolean;

	public function PlaybackControl() {
		// stop movieClip playback
		btnToBeginning.stop();
		btnPlay.stop();
		btnPause.stop();
		btnStop.stop();
	}
	public function attachSound(snd:BubbleSound) {
		if (snd == null) {
			trace("You must pass a bubbleSound object when you use the attachSound() function of a PlaybackControl object.");
			return;
		} else {
			__bubbleSnd = snd;
			//set action to occur when each button is pressed
			btnToBeginning.onAction = function() {
				_parent.toBeginning();
			};
			btnPlay.onAction = function() {
				_parent.start();
			};
			btnPause.onAction = function() {
				_parent.pause();
			};
			btnStop.onAction = function() {
				_parent.stopSound();
			};
			__bubbleSnd.isPlaying = false;
			update();
		}
	}
	public function toBeginning():Void {
		__bubbleSnd.start(0);
		//__bubbleSnd.stopSound();
		__bubbleSnd.isPlaying = true;
		update();
		btnToBeginning.enabled = true; // 
	}
	public function start():Void {
		if (!__bubbleSnd.isPlaying) {
			// if already playing, no need to reinitiate
			__bubbleSnd.start(__bubbleSnd.position);
		}
		__bubbleSnd.isPlaying = true;
		update();
		btnToBeginning.enabled = true; // 
	}
	public function pause():Void {
		__bubbleSnd.stopSound();
		__bubbleSnd.isPlaying = false;
		update();
	}
	public function stopSound():Void {
		__bubbleSnd.start(0);
		__bubbleSnd.stopSound();
		__bubbleSnd.isPlaying = false;
		update();
		//trace("in stopSound() function");
	}
	private function update():Void {
		// enable ToBeginning button only if sound file is not at beginning
		btnToBeginning.enabled = (__bubbleSnd.position != 0);
		// enable Play button only when NOT playing
		btnPlay.enabled = !(__bubbleSnd.isPlaying);
		// enable Pause & Stop buttons whenever sound file is playing
		btnPause.enabled = __bubbleSnd.isPlaying;
		btnStop.enabled = __bubbleSnd.isPlaying;
	}
	private function onEnterFrame():Void {
		// place repeating code here ...
	}
}