﻿/*
	this sound object, created for use with the BubbleMachine,
		extends the capabilities of Macromedia's basic Sound object
		
		Properties:
			sound
			duration
			position
			isPlaying
		Methods:
			constructor
			loadSound
			get duration
			get/set isPlaying
			get/set position
			sdlStart() // wraps the Sound object functionality (specifically, using ms instead of sec)
			sdlPause()
			sdlStop()
*/
class sdlSound extends Sound { // this means you "inherit" all of the capabilities built into the Sound object!!
	// properties
	private var __sound:Sound;
	private var __duration:Number;
	private var __position:Number;
	private var __isPlaying:Boolean;

	// methods
	public function sdlSound() { // constructor
		__sound = new Sound();
	}
	
	public function loadSound(filename,streaming){
		if (streaming==null){streaming=true;}
		__sound.loadSound(filename,streaming);
		__duration = __sound.duration;
		__position = 0;
	}
	
	// allow access to the sound file duration
	public function get duration():Number {
		__duration = __sound.duration;
		return __duration;
	}

	// allow access to the isPlaying property
	public function get isPlaying():Boolean {
		return __isPlaying;
	}
	
	public function set isPlaying(val:Boolean):Void {
		__isPlaying = val;
	}
	
	// set current location within soundfile ("position" is a read-only variable in ActionScript ... will this provide a workaround?)
	public function set position(loc):Void {
		__position = loc;
	}

	// get current location within soundfile
	public function get position():Number {
		__position = __sound.position;
		return __position;
	}

	public function sdlStart(msOffset:Number) {
		if (msOffset == null) {
			__sound.start();
			__isPlaying = true;
			trace(msOffset);
		} else {
			// by using this function, the bubbleSound object retains consistency across functions, always using milliseconds
			__sound.start(msOffset/1000);
			__isPlaying = true;
		}
	}
	
	public function sdlStop(){
		__sound.start(0);
		__sound.stop();
		__isPlaying = false;
	}
	
	public function sdlPause(){
		__sound.stop();
		__isPlaying = false;
		__position = __sound.position;
	}
}