﻿/*
	this sound object, created for use with the BubbleMachine,
		extends the capabilities of Macromedia's basic Sound object
		
		Properties:
			duration, position, isPlaying, txtLocation, & sound
		Methods:
			loadSound()
			get/set duration
			get/set isPlaying
			get/set position
			get txtLocation
			start() // wraps the Sound object functionality (specifically, using ms instead of sec)
			stopSound()
*/
class sdlSound extends Sound {
	// properties of the bubbleSound object
	// delegate properties using BubbleSound for Sound object
	private var __duration:Number = null;
	private var __position:Number = null;
	// length (in ms) of sound file
	private var __isPlaying:Boolean = false;
	// current location (in ms) in sound file
	private var __txtLocation:String = "";
	// text string containing mm:ss:ms values
	private var __sound:Sound;
	
	public function BubbleSound() {
		__sound = new Sound();
	}
	public function loadSound(filename,streaming){
		if (streaming==null){streaming=true;}
		__sound.loadSound(filename,streaming);
	}
	// allow access to the sound file duration
	public function get duration():Number {
		__duration = __sound.duration;
		return __duration;
	}

	// allow access to the isPlaying property
	public function get isPlaying():Boolean {
		return __isPlaying;
	}
	public function set isPlaying(val:Boolean):Void {
		__isPlaying = val;
	}
	// set current location within soundfile ("position" is a read-only variable in ActionScript ... will this provide a workaround?)
	public function set position(loc):Void {
		__position = loc;
	}

	// get current location within soundfile
	public function get position():Number {
		__position = __sound.position;
		return __position;
	}
	// output text string of minutes:seconds:milliseconds based on currLocation
	public function get txtLocation():String {
		__position = __sound.position;
		__duration = __sound.duration;
		//trace("currL: "+__currLocation+"; clipL: "+__clipLength);
		var tmpLoc:Number = __position;
		var minutes:Number = Math.floor(tmpLoc/60000);
		var txtMinutes:String = "";
		if ((__duration/60000)<10) {
			txtMinutes = String(minutes);
			// if less than 10 minutes, then need only one digit for "minutes" placeholder
		} else {
			// this assumes that a piece is never more than 99 minutes in length (wise?)
			if (minutes<10) {
				// if more than 10 minutes, "minutes" placeholder should occupy two digits
				txtMinutes = "0"+String(minutes);
				// determine whether it is necessary to add leading "0"
			} else {
				txtMinutes = String(minutes);
			}
		}
		tmpLoc = tmpLoc%60000;
		var seconds:Number = Math.floor(tmpLoc/1000);
		var txtSeconds:String = "";
		if (seconds<10) {
			txtSeconds = "0"+String(seconds);
		} else {
			txtSeconds = String(seconds);
		}
		var ms:Number = tmpLoc%1000;
		var txtMs:String = String(ms);
		switch (txtMs.length) {
		case 1 :
			txtMs = "00"+txtMs;
			break;
		case 2 :
			txtMs = "0"+txtMs;
			break;
		case 3 :
			// do nothing
		}
		__txtLocation = txtMinutes+":"+txtSeconds+":"+txtMs;
		//trace(__txtLocation);
		return __txtLocation;
	}
	public function start(msOffset) {
		if (msOffset == null) {
			__sound.start();
		} else {
			// by using this function, the bubbleSound object retains consistency across functions, always using milliseconds
			__sound.start(msOffset/1000);
		}
	}
	public function stopSound(){
		__sound.stop();
	}
}
